//+------------------------------------------------------------------+
//|                                                       EMA_BB.mq5 |
//+------------------------------------------------------------------+

#include <MovingAverages.mqh>
//---
#property indicator_chart_window
#property indicator_buffers 12
#property indicator_plots   11
#property indicator_type1   DRAW_LINE
#property indicator_color1  LightSeaGreen
#property indicator_type2   DRAW_LINE
#property indicator_color2  LightSeaGreen
#property indicator_type3   DRAW_LINE
#property indicator_color3  LightSeaGreen
#property indicator_type4   DRAW_LINE
#property indicator_color4  LightSeaGreen
#property indicator_type5   DRAW_LINE
#property indicator_color5  LightSeaGreen
#property indicator_type6   DRAW_LINE
#property indicator_color6  LightSeaGreen
#property indicator_type7   DRAW_LINE
#property indicator_color7  LightSeaGreen
#property indicator_type8   DRAW_LINE
#property indicator_color8  LightSeaGreen
#property indicator_type9   DRAW_LINE
#property indicator_color9  LightSeaGreen
#property indicator_type10   DRAW_LINE
#property indicator_color10  Aqua
#property indicator_type11   DRAW_LINE
#property indicator_color11  Aqua
#property indicator_label1  "Bands middle"
#property indicator_label2  "Bands upper 1"
#property indicator_label3  "Bands lower 1"
#property indicator_label4  "Bands upper 2"
#property indicator_label5  "Bands lower 2"
#property indicator_label6  "Bands upper 3"
#property indicator_label7  "Bands lower 3"
#property indicator_label8  "Bands upper 4"
#property indicator_label9  "Bands lower 4"
#property indicator_label10  "Bands upper 5"
#property indicator_label11  "Bands lower 5"
//--- input parametrs
input int     InpBandsPeriod=168;       // Period
input int     InpBandsShift=0;         // Shift
input double  InpBandsDeviations1=1.0;  // Deviation 1
input double  InpBandsDeviations2=2.0;  // Deviation 2
input double  InpBandsDeviations3=3.0;  // Deviation 3
input double  InpBandsDeviations4=4.0;  // Deviation 4
input double  InpBandsDeviations5=5.0;  // Deviation 5
//--- global variables
int           ExtBandsPeriod,ExtBandsShift;
double        ExtBandsDeviations;
int           ExtPlotBegin=0;
//--- indicator buffer
double        ExtMLBuffer[];
double        ExtTL1Buffer[];
double        ExtBL1Buffer[];
double        ExtTL2Buffer[];
double        ExtBL2Buffer[];
double        ExtTL3Buffer[];
double        ExtBL3Buffer[];
double        ExtTL4Buffer[];
double        ExtBL4Buffer[];
double        ExtTL5Buffer[];
double        ExtBL5Buffer[];
double        ExtStdDevBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//--- check for input values
   if(InpBandsPeriod<2)
     {
      ExtBandsPeriod=20;
      PrintFormat("Incorrect value for input variable InpBandsPeriod=%d. Indicator will use value=%d for calculations.",InpBandsPeriod,ExtBandsPeriod);
     }
   else
      ExtBandsPeriod=InpBandsPeriod;
   if(InpBandsShift<0)
     {
      ExtBandsShift=0;
      PrintFormat("Incorrect value for input variable InpBandsShift=%d. Indicator will use value=%d for calculations.",InpBandsShift,ExtBandsShift);
     }
   else
      ExtBandsShift=InpBandsShift;

//--- define buffers
   SetIndexBuffer(0,ExtMLBuffer);
   SetIndexBuffer(1,ExtTL1Buffer);
   SetIndexBuffer(2,ExtBL1Buffer);
   SetIndexBuffer(3,ExtTL2Buffer);
   SetIndexBuffer(4,ExtBL2Buffer);
   SetIndexBuffer(5,ExtTL3Buffer);
   SetIndexBuffer(6,ExtBL3Buffer);
   SetIndexBuffer(7,ExtTL4Buffer);
   SetIndexBuffer(8,ExtBL4Buffer);
   SetIndexBuffer(9,ExtTL5Buffer);
   SetIndexBuffer(10,ExtBL5Buffer);
   SetIndexBuffer(11,ExtStdDevBuffer,INDICATOR_CALCULATIONS);
//--- set index labels
   PlotIndexSetString(0,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Middle");
   PlotIndexSetString(1,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper1");
   PlotIndexSetString(2,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower1");
   PlotIndexSetString(3,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper2");
   PlotIndexSetString(4,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower2");
   PlotIndexSetString(5,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper3");
   PlotIndexSetString(6,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower3");
   PlotIndexSetString(7,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper4");
   PlotIndexSetString(8,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower4");
   PlotIndexSetString(9,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Upper5");
   PlotIndexSetString(10,PLOT_LABEL,"Bands("+string(ExtBandsPeriod)+") Lower5");
//--- indicator name
   IndicatorSetString(INDICATOR_SHORTNAME,"EMA BB");
//--- indexes draw begin settings
   ExtPlotBegin=ExtBandsPeriod-1;
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(7,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(8,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(9,PLOT_DRAW_BEGIN,ExtBandsPeriod);
   PlotIndexSetInteger(10,PLOT_DRAW_BEGIN,ExtBandsPeriod);
//--- indexes shift settings
   PlotIndexSetInteger(0,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(1,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(2,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(3,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(4,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(5,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(6,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(7,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(8,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(9,PLOT_SHIFT,ExtBandsShift);
   PlotIndexSetInteger(10,PLOT_SHIFT,ExtBandsShift);
//--- number of digits of indicator value
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
   if(rates_total<ExtPlotBegin)
      return(0);
//--- indexes draw begin settings, when we've recieved previous begin
   if(ExtPlotBegin!=ExtBandsPeriod+begin)
     {
      ExtPlotBegin=ExtBandsPeriod+begin;
      PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(5,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(6,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(7,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(8,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(9,PLOT_DRAW_BEGIN,ExtPlotBegin);
      PlotIndexSetInteger(10,PLOT_DRAW_BEGIN,ExtPlotBegin);
     }
//--- starting calculation
   int pos;
   if(prev_calculated>1)
      pos=prev_calculated-1;
   else
      pos=0;
//--- main cycle
   for(int i=pos; i<rates_total && !IsStopped(); i++)
     {
      //--- middle line
      ExtMLBuffer[i]=SimpleMA(i,ExtBandsPeriod,price);
      //--- calculate and write down StdDev
      ExtStdDevBuffer[i]=StdDev_Func(i,price,ExtMLBuffer,ExtBandsPeriod);
      //--- upper line
      ExtTL1Buffer[i]=ExtMLBuffer[i]+InpBandsDeviations1*ExtStdDevBuffer[i];
      //--- lower line
      ExtBL1Buffer[i]=ExtMLBuffer[i]-InpBandsDeviations1*ExtStdDevBuffer[i];
      //--- upper line 2
      ExtTL2Buffer[i]=ExtMLBuffer[i]+InpBandsDeviations2*ExtStdDevBuffer[i];
      //--- lower line 2
      ExtBL2Buffer[i]=ExtMLBuffer[i]-InpBandsDeviations2*ExtStdDevBuffer[i];
      //--- upper line 3
      ExtTL3Buffer[i]=ExtMLBuffer[i]+InpBandsDeviations3*ExtStdDevBuffer[i];
      //--- lower line 3
      ExtBL3Buffer[i]=ExtMLBuffer[i]-InpBandsDeviations3*ExtStdDevBuffer[i];
      //--- upper line 4
      ExtTL4Buffer[i]=ExtMLBuffer[i]+InpBandsDeviations4*ExtStdDevBuffer[i];
      //--- lower line 4
      ExtBL4Buffer[i]=ExtMLBuffer[i]-InpBandsDeviations4*ExtStdDevBuffer[i];
      //--- upper line 5
      ExtTL5Buffer[i]=ExtMLBuffer[i]+InpBandsDeviations5*ExtStdDevBuffer[i];
      //--- lower line 5
      ExtBL5Buffer[i]=ExtMLBuffer[i]-InpBandsDeviations5*ExtStdDevBuffer[i];
     }
//--- OnCalculate done. Return new prev_calculated.
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Calculate Standard Deviation                                     |
//+------------------------------------------------------------------+
double StdDev_Func(const int position,const double &price[],const double &ma_price[],const int period)
  {
   double std_dev=0.0;
//--- calcualte StdDev
   if(position>=period)
     {
      for(int i=0; i<period; i++)
         std_dev+=MathPow(price[position-i]-ma_price[position],2.0);
      std_dev=MathSqrt(std_dev/period);
     }
//--- return calculated value
   return(std_dev);
  }
//+------------------------------------------------------------------+

